/*
 *
 */

#ifndef __CARLOCK_APPVIEW_H__
#define __CARLOCK_APPVIEW_H__

#include <coecntrl.h>

#include "carlock_timer.h"

class CCarLockAppView : public CCoeControl,
		        public MCarLockTimeOutNotify
{
    public: // New methods

        static CCarLockAppView* NewL( const TRect& aRect );
        static CCarLockAppView* NewLC( const TRect& aRect );
        virtual ~CCarLockAppView();

    public:  // Functions from base classes

        void Draw( const TRect& aRect ) const;
        virtual void SizeChanged();

	void SetDevice( const TDesC& aText );
	void SetStat( const TDesC& aText );
	void SetVoltage( const TReal32 aValue );
	void FlashLed();

    protected:
	void TimerExpired();

    private:

        CCarLockAppView();
	void ConstructL( const TRect& aRect );

	void CreateBackBufferL();
	void ReleaseBackBuffer();
        void DrawToBackBuffer();
	void DrawStatic( TInt y, const TDesC& aText, TBool aDrawNow );
	void DrawLed( TInt y, const TRgb& aColor, TBool aDrawNow );

    private:

        CFbsBitmap*		iBmp;
        CFbsBitmapDevice*	iDev;
        CFbsBitGc*		iGc;
        TSize			iGcSize;

	CCarLockTimer*		iTimer;
				
	TBuf<128>	iDevice;
	TBuf<128>	iStat;
	TBuf<128>	iVoltage;
	
	TRgb		iLedColor;
};

#endif // __CARLOCK_APPVIEW_H__
