/*
 *
 */

#ifndef __CARLOCK_CONSOLE_H__
#define __CARLOCK_CONSOLE_H__

#include <coecntrl.h>

class CCarLockConsole : public CCoeControl
{
    public: // New methods

        static CCarLockConsole* NewL( const TRect& aRect );
        static CCarLockConsole* NewLC( const TRect& aRect );
        virtual ~CCarLockConsole();

    public:  // Functions from base classes

        void Draw( const TRect& aRect ) const;
        virtual void SizeChanged();

	void Print( TRefByValue < const TDesC > aFmt, ... );

    private:

        CCarLockConsole();
	void ConstructL( const TRect& aRect );

	void CreateBackBufferL();
	void ReleaseBackBuffer();
        void DrawToBackBuffer();
	void AddLine( const TDesC& aText, TBool aDrawNow );

    private:

        CFbsBitmap*		iBmp;
        CFbsBitmapDevice*	iDev;
        CFbsBitGc*		iGc;
        TSize			iGcSize;
				
	TBuf<128>	iText;
};

#endif // __CARLOCK_CONSOLE_H__
