/*
 *
 */

#ifndef __CARLOCK_SETTINGS_H__
#define __CARLOCK_SETTINGS_H__

#include <coecntrl.h>
#include <aknsettingitemlist.h> 

class CCarLockSettings : public CAknSettingItemList
{
    public:

	void SizeChanged();
	void ConstructL();
	CAknSettingItem* CreateSettingItemL( TInt id );

	const TDesC& GetDevice();
	const TDesC& GetAddress();
	TInt GetChannel();
	TInt GetDelay();
	TInt GetSearchInt();
	const TDesC& GetPassword();
	TReal32 GetVddScale();

	void SaveSettings();

    private:

	void TDesC_to_str( char* dst, const TDesC& src );
	void ParseConfig( char * config );
	void GetConfigInt( char * string, char * name, TInt& val );
	void GetConfigStr( char * string, char * name, TDes& val );
	void SaveConfig( char * config );

    private:

	TBuf<256>		device;
	TBuf<64>		address;
	TBuf<64>		channel;
	TBuf<64>		delay;
	TBuf<64>		searchint;
	TBuf<64>		pass;
	TBuf<64>		vddscale;
};

#endif // __CARLOCK_SETTINGS_H__
