/*
 * Time-out timer class
 */

#include    "carlock_timer.h"

CCarLockTimer* CCarLockTimer::NewL( MCarLockTimeOutNotify& aTimeOutNotify )
{
    CCarLockTimer* self = new( ELeave ) CCarLockTimer( aTimeOutNotify );
    
    CleanupStack::PushL( self );
    self->ConstructL();
    CleanupStack::Pop( self );

    return self;
}

CCarLockTimer::CCarLockTimer( MCarLockTimeOutNotify& aTimeOutNotify ) :
    CTimer( EPriorityStandard ),
    iNotifier( aTimeOutNotify )
{
    CActiveScheduler::Add( this );
}

void CCarLockTimer::ConstructL()
{
    CTimer::ConstructL();
}

CCarLockTimer::~CCarLockTimer()
{
    Cancel();
}

void CCarLockTimer::RunL()
{
    iNotifier.TimerExpired();
}
